﻿using System;
using System.Web.Mvc;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.MvcEdition;

namespace DisplayASimpleMap.Controllers
{
    public class DisplayASimpleMapController : Controller
    {
        public ActionResult DisplayASimpleMap()
        {
            Map map = new Map("Map1",
                new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage),
                new System.Web.UI.WebControls.Unit(100, System.Web.UI.WebControls.UnitType.Percentage));

            map.MapUnit = GeographyUnit.Meter;

            map.MapBackground = new BackgroundLayer(new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF")));

            Proj4Projection proj4 = new Proj4Projection(4326, 3857);
            proj4.Open();
            ShapeFileFeatureLayer shp = new ShapeFileFeatureLayer(Server.MapPath("~/app_data/usstates.shp"));
            shp.FeatureSource.Projection = proj4;
            shp.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.Country1;
            shp.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay lo = new LayerOverlay("local");
            lo.IsBaseOverlay = true;
            lo.Layers.Add(shp);
            map.CustomOverlays.Add(lo);

            map.CustomOverlays.Add(new GoogleOverlay("google") { IsBaseOverlay = true });
            map.CustomOverlays.Add(new OpenStreetMapOverlay("OSM") { IsBaseOverlay = true });

            return View(map);
        }
    }
}